//+----------------------------------------------------------------------------+
//|                                                        test_CorrectTF.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  26.05.2008      CorrectTF().                  |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"
#property show_inputs

extern int tf=23;
void start() {
  bool   f_DataReaded=False;
  double rsi;

  while (!f_DataReaded || GetLastError()==4066) {
    rsi=iRSI(NULL, tf, 8, 0, 1);
    f_DataReaded=True;
  }
  Message("tf="+tf+" rsi="+rsi+" err="+GetLastError());

  tf=CorrectTF(tf);
  f_DataReaded=False;
  while (!f_DataReaded || GetLastError()==4066) {
    rsi=iRSI(NULL, tf, 8, 0, 1);
    f_DataReaded=True;
  }
  Message("tf="+tf+" rsi="+rsi+" err="+GetLastError());
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 02.03.2008                                                     |
//|   :      4.       |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
int CorrectTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  if (TimeFrame< PERIOD_M5                         ) return(PERIOD_M1);
  if (TimeFrame>=PERIOD_M5  && TimeFrame<PERIOD_M15) return(PERIOD_M5);
  if (TimeFrame>=PERIOD_M15 && TimeFrame<PERIOD_M30) return(PERIOD_M15);
  if (TimeFrame>=PERIOD_M30 && TimeFrame<PERIOD_H1 ) return(PERIOD_M30);
  if (TimeFrame>=PERIOD_H1  && TimeFrame<PERIOD_H4 ) return(PERIOD_H1);
  if (TimeFrame>=PERIOD_H4  && TimeFrame<PERIOD_D1 ) return(PERIOD_H4);
  if (TimeFrame>=PERIOD_D1  && TimeFrame<PERIOD_W1 ) return(PERIOD_D1);
  if (TimeFrame>=PERIOD_W1  && TimeFrame<PERIOD_MN1) return(PERIOD_W1);
  if (TimeFrame>=PERIOD_MN1                        ) return(PERIOD_MN1);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+

